import logging
import logging.config

LOGGING = {
    'version': 1,
    'incremental': False,
    'disable_existing_loggers': False,
    'loggers': {
        'libutilitaspy': {
            'level':     'INFO',
            'propagate': True,
            'handlers':  ['libutilitaspy_logfile']
        }
    },
    'handlers': {
        'libutilitaspy_logfile': {
            'class':        'logging.handlers.RotatingFileHandler',
            'level':        'INFO',
            'formatter':    'precise',
            'filename':     '/tmp/libutilitaspy.log',
            'mode':         'a', 
            'maxBytes':     65536,
            'backupCount':  4
        }
    },
    'formatters': {
        'brief':   { 'format': '%(levelname)-8s: %(message)s' },
        'precise': { 'format': '%(asctime)s %(levelname)-8s: %(name)-30s %(module)-20s %(funcName)-25s (%(lineno)5d): %(message)s' }
    }
}

logging.config.dictConfig(LOGGING)

logger = logging.getLogger(__name__)

