"""
Module: posets
Author: Ernesto Posse
Description: 
  An implementation of partially or totally ordered sets.
"""

class Bottom(object):
    
    def __init__(self):
        self.name = 'bot'
        
    def __cmp__(self, other):
        if isinstance(other, Bottom):
            return 0
        return -1
    
    def __hash__(self):
        return hash(self.name)
        
    
class Top(object):
    
    def __init__(self):
        self.name = 'top'
        
    def __cmp__(self, other):
        if isinstance(other, Top):
            return 0
        return 1
        
    def __hash__(self):
        return hash(self.name)
        

class Poset(object):
    
    def le(self, x, y):
        """
        Should return 
            True  if x <= y
            False if x > y
            None  otherwise, i.e. if x and y are not comparable
        """
        return x <= y

